#ifndef VGOLF_AVATAR_H
#define VGOLF_AVATAR_H

#include "t3f/t3f.h"
#include "t3f/animation.h"

#define VGOLF_MAX_AVATARS       256
#define VGOLF_AVATAR_MAX_IMAGES   4

typedef struct
{

	T3F_ANIMATION * source_image;
	T3F_ANIMATION * image[VGOLF_AVATAR_MAX_IMAGES];

	/* tags */
	char name[256];
	char author[256];
	char comment[1024];

} VGOLF_AVATAR;

void vgolf_build_avatar_from_source(VGOLF_AVATAR * ap);
void vgolf_rebuild_avatar_from_source(VGOLF_AVATAR * ap);
VGOLF_AVATAR * vgolf_load_avatar(const char * fn, void * palette, const ALLEGRO_FILE_INTERFACE * fi);
int vgolf_save_avatar(VGOLF_AVATAR * ap, void * pal, const char * fn);
void vgolf_destroy_avatar(VGOLF_AVATAR * ap);

#endif
