#include "core/course.h"

#include "ui_dialog_proc.h"
#include "main.h"
#include "ui_menu_proc.h"

const int crsed_object_type[] =
{
	VERT_FLAG_TEE, // {"TEE", crsed_menu_object_type_TEE, NULL, 0, NULL},
	VERT_FLAG_HOLE, //{"CUP", crsed_menu_object_type_CUP, NULL, 0, NULL},
	0,
	VERT_FLAG_TREE_0, //{"TREE_0", crsed_menu_object_type_TREE_0, NULL, 0, NULL},
	VERT_FLAG_TREE_1, //{"TREE_1", crsed_menu_object_type_TREE_1, NULL, 0, NULL},
	VERT_FLAG_ANIMAL_0, //{"ANIMAL_0", crsed_menu_object_type_ANIMAL_0, NULL, 0, NULL},
	VERT_FLAG_ANIMAL_1, //{"ANIMAL_1", crsed_menu_object_type_ANIMAL_1, NULL, 0, NULL},
	0,
	VERT_FLAG_HAZARD_WATER, //{"HAZARD_WATER", crsed_menu_object_type_HAZARD_WATER, NULL, 0, NULL},
	VERT_FLAG_HAZARD_SAND, //{"HAZARD_SAND", crsed_menu_object_type_HAZARD_SAND, NULL, 0, NULL},
	VERT_FLAG_HAZARD_ROUGH, //{"HAZARD_ROUGH", crsed_menu_object_type_HAZARD_ROUGH, NULL, 0, NULL},
	VERT_FLAG_HAZARD_SLIME, //{"HAZARD_SLIME", crsed_menu_object_type_HAZARD_SLIME, NULL, 0, NULL},
	VERT_FLAG_INDENT_HILL, //{"HILL", crsed_menu_object_type_HILL, NULL, 0, NULL},
	VERT_FLAG_INDENT_RUT, //{"RUT", crsed_menu_object_type_RUT, NULL, 0, NULL},
	0,
	VERT_FLAG_PIPE_ENTER, //{"PIPE_ENTER", crsed_menu_object_type_PIPE_ENTER, NULL, 0, NULL},
	VERT_FLAG_PIPE_EXIT, //{"PIPE_EXIT", crsed_menu_object_type_PIPE_EXIT, NULL, 0, NULL},
	VERT_FLAG_TELEPORT, //{"TELEPORT", crsed_menu_object_type_TELEPORT, NULL, 0, NULL},
	0,
	VERT_FLAG_CLOUD_HORIZ, //{"CLOUD_HORIZ", crsed_menu_object_type_CLOUD_HORIZ, NULL, 0, NULL},
	VERT_FLAG_CLOUD_VERT, //{"CLOUD_VERT", crsed_menu_object_type_CLOUD_VERT, NULL, 0, NULL},
	VERT_FLAG_BUBBLE_HORIZ, //{"CLOUD_HORIZ", crsed_menu_object_type_CLOUD_HORIZ, NULL, 0, NULL},
	VERT_FLAG_BUBBLE_VERT, //{"CLOUD_VERT", crsed_menu_object_type_CLOUD_VERT, NULL, 0, NULL},
	VERT_FLAG_BLINKER, //{"BLINKER", crsed_menu_object_type_BLINKER, NULL, 0, NULL},
	0,
	VERT_FLAG_LASER_SEND, //{"LASER_SEND", crsed_menu_object_type_LASER_SEND, NULL, 0, NULL},
	VERT_FLAG_LASER_RECV, //{"LASER_RECEIVE", crsed_menu_object_type_LASER_RECEIVE, NULL, 0, NULL},
	VERT_FLAG_LASER_RESPAWN, //{"LASER_RESPAWN", crsed_menu_object_type_LASER_RESPAWN, NULL, 0, NULL},
	0,
	VERT_FLAG_POLY_MORPH, //{"POLY_MORPH", crsed_menu_object_type_POLY_MORPH, NULL, 0, NULL},
	VERT_FLAG_POLY_MOTION_AREA, //{"POLY_MOTION_AREA", crsed_menu_object_type_POLY_MOTION_AREA, NULL, 0, NULL},
	VERT_FLAG_POLY_MOVE_HORIZ, //{"POLY_MOVE_HORIZ", crsed_menu_object_type_POLY_MOVE_HORIZ, NULL, 0, NULL},
	VERT_FLAG_POLY_MOVE_VERT, //{"POLY_MOVE_VERT", crsed_menu_object_type_POLY_MOVE_VERT, NULL, 0, NULL},
	VERT_FLAG_POLY_DOOR_HORIZ, //{"DOOR_HORIZ", crsed_menu_object_type_DOOR_HORIZ, NULL, 0, NULL},
	VERT_FLAG_POLY_DOOR_VERT, //{"DOOR_VERTICAL", crsed_menu_object_type_DOOR_VERTICAL, NULL, 0, NULL},
	VERT_FLAG_SMASH_RESPAWN, //{"DOOR_RESPAWN", crsed_menu_object_type_DOOR_RESPAWN, NULL, 0, NULL},
	VERT_FLAG_CONVEYOR, //{"CONVEYOR", crsed_menu_object_type_CONVEYOR, NULL, 0, NULL},
	VERT_FLAG_LAYER_TRANSFER, //{"CONVEYOR", crsed_menu_object_type_CONVEYOR, NULL, 0, NULL},
	VERT_FLAG_TRANSLUCENCY //{"CONVEYOR", crsed_menu_object_type_CONVEYOR, NULL, 0, NULL},
};

const char * crsed_object_type_name[] =
{
	"TEE", // {"TEE", crsed_menu_object_type_TEE, NULL, 0, NULL},
	"CUP", //{"CUP", crsed_menu_object_type_CUP, NULL, 0, NULL},
	NULL,
	"TREE 0", //{"TREE_0", crsed_menu_object_type_TREE_0, NULL, 0, NULL},
	"TREE 1", //{"TREE_1", crsed_menu_object_type_TREE_1, NULL, 0, NULL},
	"ANIMAL 0", //{"ANIMAL_0", crsed_menu_object_type_ANIMAL_0, NULL, 0, NULL},
	"ANIMAL 1", //{"ANIMAL_1", crsed_menu_object_type_ANIMAL_1, NULL, 0, NULL},
	NULL,
	"HAZARD WATER", //{"HAZARD_WATER", crsed_menu_object_type_HAZARD_WATER, NULL, 0, NULL},
	"HAZARD SAND", //{"HAZARD_SAND", crsed_menu_object_type_HAZARD_SAND, NULL, 0, NULL},
	"HAZARD ROUGH", //{"HAZARD_ROUGH", crsed_menu_object_type_HAZARD_ROUGH, NULL, 0, NULL},
	"HAZARD SLIME", //{"HAZARD_SLIME", crsed_menu_object_type_HAZARD_SLIME, NULL, 0, NULL},
	"INDENT HILL", //{"HILL", crsed_menu_object_type_HILL, NULL, 0, NULL},
	"INDENT RUT", //{"RUT", crsed_menu_object_type_RUT, NULL, 0, NULL},
	NULL,
	"PIPE ENTER", //{"PIPE_ENTER", crsed_menu_object_type_PIPE_ENTER, NULL, 0, NULL},
	"PIPE EXIT", //{"PIPE_EXIT", crsed_menu_object_type_PIPE_EXIT, NULL, 0, NULL},
	"TELEPORT", //{"TELEPORT", crsed_menu_object_type_TELEPORT, NULL, 0, NULL},
	NULL,
	"CLOUD HORIZ", //{"CLOUD_HORIZ", crsed_menu_object_type_CLOUD_HORIZ, NULL, 0, NULL},
	"CLOUD VERT", //{"CLOUD_VERT", crsed_menu_object_type_CLOUD_VERT, NULL, 0, NULL},
	"BUBBLE HORIZ", //{"CLOUD_HORIZ", crsed_menu_object_type_CLOUD_HORIZ, NULL, 0, NULL},
	"BUBBLE VERT", //{"CLOUD_VERT", crsed_menu_object_type_CLOUD_VERT, NULL, 0, NULL},
	"BLINKER", //{"BLINKER", crsed_menu_object_type_BLINKER, NULL, 0, NULL},
	NULL,
	"LASER SEND", //{"LASER_SEND", crsed_menu_object_type_LASER_SEND, NULL, 0, NULL},
	"LASER RECV", //{"LASER_RECEIVE", crsed_menu_object_type_LASER_RECEIVE, NULL, 0, NULL},
	"LASER RESPAWN", //{"LASER_RESPAWN", crsed_menu_object_type_LASER_RESPAWN, NULL, 0, NULL},
	NULL,
	"POLY MORPH", //{"POLY_MORPH", crsed_menu_object_type_POLY_MORPH, NULL, 0, NULL},
	"POLY MOTION AREA", //{"POLY_MOTION_AREA", crsed_menu_object_type_POLY_MOTION_AREA, NULL, 0, NULL},
	"POLY MOVE HORIZ", //{"POLY_MOVE_HORIZ", crsed_menu_object_type_POLY_MOVE_HORIZ, NULL, 0, NULL},
	"POLY MOVE VERT", //{"POLY_MOVE_VERT", crsed_menu_object_type_POLY_MOVE_VERT, NULL, 0, NULL},
	"POLY DOOR HORIZ", //{"DOOR_HORIZ", crsed_menu_object_type_DOOR_HORIZ, NULL, 0, NULL},
	"POLY DOOR VERT", //{"DOOR_VERTICAL", crsed_menu_object_type_DOOR_VERTICAL, NULL, 0, NULL},
	"SMASH RESPAWN", //{"DOOR_RESPAWN", crsed_menu_object_type_DOOR_RESPAWN, NULL, 0, NULL},
	"CONVEYOR", //{"CONVEYOR", crsed_menu_object_type_CONVEYOR, NULL, 0, NULL},
	"LAYER TRANSFER", //{"CONVEYOR", crsed_menu_object_type_CONVEYOR, NULL, 0, NULL},
	"TRANSLUCENCY" //{"CONVEYOR", crsed_menu_object_type_CONVEYOR, NULL, 0, NULL},
};

const char * crsed_image_type_name[] =
{
	"Title",
	"Scoreboard",
	"End BG",
	"End Podium",
	"End Cloud 1",
	"End Cloud 2",
	"1st Trophy",
	"2nd Trophy",
	"3rd Trophy",
	"Cup",
	"Cup Sunk",
	"Tree 1",
	"Tree 2",
	"Laser Off",
	"Laser On",
	"Teleport 1",
	"Teleport 2",
	"Conveyor 1",
	"Conveyor 2",
	"Conveyor 3",
	"Conveyor 4",
	"Animal 1 Right 1",
	"Animal 1 Right 2",
	"Animal 1 Left 1",
	"Animal 1 Left 2",
	"Animal 2 Right 1",
	"Animal 2 Right 2",
	"Animal 2 Left 1",
	"Animal 2 Left 2"
};

const menu_proc_ptr_t crsed_object_type_proc[] =
{
	crsed_menu_object_type_TEE, // {"TEE", crsed_menu_object_type_TEE, NULL, 0, NULL},
	crsed_menu_object_type_CUP, //{"CUP", crsed_menu_object_type_CUP, NULL, 0, NULL},
	0,
	crsed_menu_object_type_TREE_0, //{"TREE_0", crsed_menu_object_type_TREE_0, NULL, 0, NULL},
	crsed_menu_object_type_TREE_1, //{"TREE_1", crsed_menu_object_type_TREE_1, NULL, 0, NULL},
	crsed_menu_object_type_ANIMAL_0, //{"ANIMAL_0", crsed_menu_object_type_ANIMAL_0, NULL, 0, NULL},
	crsed_menu_object_type_ANIMAL_1, //{"ANIMAL_1", crsed_menu_object_type_ANIMAL_1, NULL, 0, NULL},
	0,
	crsed_menu_object_type_HAZARD_WATER, //{"HAZARD_WATER", crsed_menu_object_type_HAZARD_WATER, NULL, 0, NULL},
	crsed_menu_object_type_HAZARD_SAND, //{"HAZARD_SAND", crsed_menu_object_type_HAZARD_SAND, NULL, 0, NULL},
	crsed_menu_object_type_HAZARD_ROUGH, //{"HAZARD_ROUGH", crsed_menu_object_type_HAZARD_ROUGH, NULL, 0, NULL},
	crsed_menu_object_type_HAZARD_SLIME, //{"HAZARD_SLIME", crsed_menu_object_type_HAZARD_SLIME, NULL, 0, NULL},
	crsed_menu_object_type_HILL, //{"HILL", crsed_menu_object_type_HILL, NULL, 0, NULL},
	crsed_menu_object_type_RUT, //{"RUT", crsed_menu_object_type_RUT, NULL, 0, NULL},
	0,
	crsed_menu_object_type_PIPE_ENTER, //{"PIPE_ENTER", crsed_menu_object_type_PIPE_ENTER, NULL, 0, NULL},
	crsed_menu_object_type_PIPE_EXIT, //{"PIPE_EXIT", crsed_menu_object_type_PIPE_EXIT, NULL, 0, NULL},
	crsed_menu_object_type_TELEPORT, //{"TELEPORT", crsed_menu_object_type_TELEPORT, NULL, 0, NULL},
	0,
	crsed_menu_object_type_CLOUD_HORIZ, //{"CLOUD_HORIZ", crsed_menu_object_type_CLOUD_HORIZ, NULL, 0, NULL},
	crsed_menu_object_type_CLOUD_VERT, //{"CLOUD_VERT", crsed_menu_object_type_CLOUD_VERT, NULL, 0, NULL},
	crsed_menu_object_type_BUBBLE_HORIZ, //{"CLOUD_HORIZ", crsed_menu_object_type_CLOUD_HORIZ, NULL, 0, NULL},
	crsed_menu_object_type_BUBBLE_VERT, //{"CLOUD_VERT", crsed_menu_object_type_CLOUD_VERT, NULL, 0, NULL},
	crsed_menu_object_type_BLINKER, //{"BLINKER", crsed_menu_object_type_BLINKER, NULL, 0, NULL},
	0,
	crsed_menu_object_type_LASER_SEND, //{"LASER_SEND", crsed_menu_object_type_LASER_SEND, NULL, 0, NULL},
	crsed_menu_object_type_LASER_RECEIVE, //{"LASER_RECEIVE", crsed_menu_object_type_LASER_RECEIVE, NULL, 0, NULL},
	crsed_menu_object_type_LASER_RESPAWN, //{"LASER_RESPAWN", crsed_menu_object_type_LASER_RESPAWN, NULL, 0, NULL},
	0,
	crsed_menu_object_type_POLY_MORPH, //{"POLY_MORPH", crsed_menu_object_type_POLY_MORPH, NULL, 0, NULL},
	crsed_menu_object_type_POLY_MOTION_AREA, //{"POLY_MOTION_AREA", crsed_menu_object_type_POLY_MOTION_AREA, NULL, 0, NULL},
	crsed_menu_object_type_POLY_MOVE_HORIZ, //{"POLY_MOVE_HORIZ", crsed_menu_object_type_POLY_MOVE_HORIZ, NULL, 0, NULL},
	crsed_menu_object_type_POLY_MOVE_VERT, //{"POLY_MOVE_VERT", crsed_menu_object_type_POLY_MOVE_VERT, NULL, 0, NULL},
	crsed_menu_object_type_DOOR_HORIZ, //{"DOOR_HORIZ", crsed_menu_object_type_DOOR_HORIZ, NULL, 0, NULL},
	crsed_menu_object_type_DOOR_VERTICAL, //{"DOOR_VERTICAL", crsed_menu_object_type_DOOR_VERTICAL, NULL, 0, NULL},
	crsed_menu_object_type_DOOR_RESPAWN, //{"DOOR_RESPAWN", crsed_menu_object_type_DOOR_RESPAWN, NULL, 0, NULL},
	crsed_menu_object_type_CONVEYOR, //{"CONVEYOR", crsed_menu_object_type_CONVEYOR, NULL, 0, NULL},
	crsed_menu_object_type_LAYER_TRANSFER, //{"CONVEYOR", crsed_menu_object_type_CONVEYOR, NULL, 0, NULL},
	crsed_menu_object_type_TRANSLUCENCY //{"CONVEYOR", crsed_menu_object_type_CONVEYOR, NULL, 0, NULL},
};
