#include "t3f/t3f.h"
#include "instance.h"
#include "main.h"
#include "ui_dialog_proc.h"
#include "draw.h"
#include "ui_vert.h"
#include "ui.h"
#include "ui_menu_proc.h"

/* a = (c * sin(A)) / sin(C) */
al_fixed solve_asa_triangle_a(al_fixed A, al_fixed c, al_fixed B)
{
	al_fixed C = al_fixsub(al_itofix(128), al_fixadd(A, B));
	return al_fixdiv(al_fixmul(c, al_fixsin(A)), al_fixsin(C));
}

/* b = (c * sin(B)) / sin(C) */
al_fixed solve_asa_triangle_b(al_fixed A, al_fixed c, al_fixed B)
{
	al_fixed C = al_fixsub(al_itofix(128), al_fixadd(A, B));
	return al_fixdiv(al_fixmul(c, al_fixsin(B)), al_fixsin(C));
}

void crsed_poly_logic(void * data)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;
	int i, j;
	int a, b, c;
	al_fixed angle;
	al_fixed hypotenuse;
	int iangle;
	int A = 0;

	crsed_camera_logic(data);
	app->hover_poly = app->new_poly;
	app->hover_point = app->new_poly;
	if(app->hover_poly < 0)
	{
		for(i = 0; i < app->course->hole[app->selected_hole].bodies[app->selected_layer]; i++)
		{
			for(j = 0; j < app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.num_vertices; j++)
			{
				if(app->mouse_x >= app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].x + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.x - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].x + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.x + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].y + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].y + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.y + PEG_RADIUS)
				{
					app->hover_poly = i;
					app->hover_point = j;
					crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
					break;
				}
			}
		}
	}
	if(app->hover_poly < 0 && !app->dragging)
	{
		crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_DEFAULT);
	}
	if(app->mouse_b & 1)
	{
		app->click_tick++;
		if(app->click_tick == 1)
		{
			if(app->new_poly >= 0 && app->new_point >= 0)
			{
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices--;
				if(app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices < 2)
				{
					app->course->hole[app->selected_hole].bodies[app->selected_layer]--;
				}
				else if(app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices > 2)
				{
					if(t3f_distance(app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 1].x, app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 1].y, app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[0].x, app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[0].y) < 4)
					{
						memcpy(&app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 1], &app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[0], sizeof(VERTEX));
					}
					else
					{
						memcpy(&app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices], &app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[0], sizeof(VERTEX));
						app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices++;
					}
					app->selected_poly = app->new_poly;
					t3f_refresh_menus();
					crsed_mark_change(data);
				}
				app->new_poly = -1;
				app->new_point = -1;
			}
			else if(app->hover_poly >= 0 && app->hover_point >= 0)
			{
				if(!app->dragging)
				{
					app->selected_poly = app->hover_poly;
					app->selected_point = app->hover_point;
					app->peg_x = app->mouse_x - app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.p[app->selected_point].x - 320;
					app->peg_y = app->mouse_y - app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.p[app->selected_point].y - 240;
					app->dragging = 1;
				}
			}
		}
		else
		{
			if(app->dragging)
			{
				if(app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.p[app->selected_point].x != app->mouse_x - app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].pos.x - app->peg_x || app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.p[app->selected_point].y != app->mouse_y - app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].pos.y - app->peg_y)
				{
					app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.p[app->selected_point].x = app->mouse_x - app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].pos.x - app->peg_x;
					app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.p[app->selected_point].y = app->mouse_y - app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].pos.y - app->peg_y;
					if(app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.num_vertices > 2)
					{
						if(app->selected_point == 0)
						{
							app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.num_vertices - 1].x = app->mouse_x - app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].pos.x - app->peg_x;
							app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.num_vertices - 1].y = app->mouse_y - app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].pos.y - app->peg_y;
						}
						else if(app->selected_point == app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.num_vertices - 1)
						{
							app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.p[0].x = app->mouse_x - app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].pos.x - app->peg_x;
							app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].poly.p[0].y = app->mouse_y - app->course->hole[app->selected_hole].body[app->selected_layer][app->selected_poly].pos.y - app->peg_y;
						}
					}
					crsed_mark_change(data);
				}
			}
		}
	}
	else if((app->mouse_b & 2) || t3f_key[ALLEGRO_KEY_INSERT])
	{
		app->click_tick++;
		if(app->click_tick == 1)
		{
			if(app->new_poly < 0 && app->new_point < 0 && app->course->hole[app->selected_hole].bodies[app->selected_layer] < MAX_HOLE_POLYS)
			{
				app->new_poly = app->course->hole[app->selected_hole].bodies[app->selected_layer];
				app->new_point = 0;
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.x = 320;
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.y = 240;
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[0].x = app->mouse_x - app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.x;
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[0].y = app->mouse_y - app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.y;
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[1].x = app->mouse_x - app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.x;
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[1].y = app->mouse_y - app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.y;
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices = 2;
				app->course->hole[app->selected_hole].bodies[app->selected_layer]++;
			}
			else if(app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices < MAX_OBJECT_VERTICES - 2)
			{
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices].x = app->mouse_x - app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.x;
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices].y = app->mouse_y - app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.y;
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices++;
			}
		}
	}
	else
	{
		app->click_tick = 0;
		app->dragging = 0;
		if(app->new_poly >= 0 && app->new_point >= 0)
		{
			crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_PRECISION);
			/* handle angle snap logic */
			if(t3f_key[ALLEGRO_KEY_LCTRL])
			{
				/* to-do: figure out how to close the gap so vertex is placed at the same x- or y-coordinate as the mouse */
				if(app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices > 1)
				{
					a = app->mouse_x - (app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 2].x + app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.x);
					b = app->mouse_y - (app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 2].y + app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.y);
					angle = al_fixatan2(al_itofix(a), al_itofix(b));
					if(angle < 0)
					{
						c = -8;
					}
					else
					{
						c = 8;
					}
					iangle = -((al_fixtoi(angle) + c) / 16) * 16 + 64;
					if(iangle < 0)
					{
						iangle += 256;
					}
					if(iangle == 0 || iangle == 128)
					{
						hypotenuse = al_itofix(abs(a));
					}
					else if(iangle == 64 || iangle == 192)
					{
						hypotenuse = al_itofix(abs(b));
					}
					else
					{
						switch(iangle)
						{
							case 16:
							{
								A = 16;
								break;
							}
							case 32:
							{
								A = 64 - 32;
								break;
							}
							case 48:
							{
								A = 64 - 48;
								break;
							}
							case 80:
							{
								A = 80 - 64;
								break;
							}
							case 96:
							{
								A = 96 - 64;
								break;
							}
							case 112:
							{
								A = 16;
								break;
							}
							case 144:
							{
								A = 144 - 128;
								break;
							}
							case 160:
							{
								A = 160 - 128;
								break;
							}
							case 176:
							{
								A = 16;
								break;
							}
							case 208:
							{
								A = 208 - 192;
								break;
							}
							case 224:
							{
								A = 224 - 192;
								break;
							}
							case 240:
							{
								A = 16;
								break;
							}
						}
						if(abs(a) < abs(b))
						{
							hypotenuse = solve_asa_triangle_b(al_itofix(A), al_itofix(abs(b)), al_itofix(64));
						}
						else
						{
							hypotenuse = solve_asa_triangle_b(al_itofix(A), al_itofix(abs(a)), al_itofix(64));
						}
					}
					app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 1].x = app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 2].x + al_fixtoi(al_fixmul(al_fixcos(al_itofix(iangle)), hypotenuse));
					app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 1].y = app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 2].y + al_fixtoi(al_fixmul(al_fixsin(al_itofix(iangle)), hypotenuse));
				}
			}
			else
			{
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 1].x = app->mouse_x - app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.x;
				app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.p[app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].poly.num_vertices - 1].y = app->mouse_y - app->course->hole[app->selected_hole].body[app->selected_layer][app->new_poly].pos.y;
			}
		}
	}
}

void crsed_poly_render_single(void * data, int i, ALLEGRO_COLOR color, int handles)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;
	int j;
	int mx, my;
	al_fixed nangle;

	for(j = 0; j < app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.num_vertices - 1; j++)
	{
		draw_line(data, NULL, app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].x + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.x, app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].y + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.y, app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j + 1].x + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.x, app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j + 1].y + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.y, color);
		mx = (app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].x + app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j + 1].x) / 2;
		my = (app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].y + app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j + 1].y) / 2;
		nangle = al_fixatan2(al_itofix(app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j + 1].y - app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].y), al_itofix(app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j + 1].x - app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].x)) + al_itofix(64);
		draw_line(data, NULL, mx + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.x, my + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.y, mx + al_fixtof(al_fixcos(nangle)) * 16.0 + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.x, my + al_fixtof(al_fixsin(nangle)) * 16.0 + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.y, color);
		if(handles)
		{
			draw_handle(data, NULL, app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].x + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.x, app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].y + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.y, ((i == app->hover_poly && j == app->hover_point) || (i == app->selected_poly && j == app->selected_point)) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
		}
	}
	if(handles)
	{
		draw_handle(data, NULL, app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].x + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.x, app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].y + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.y, ((i == app->hover_poly && (j == app->hover_point || app->hover_point == 0)) || (i == app->selected_poly && (j == app->selected_point || app->selected_point == 0))) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
	}
}

void crsed_poly_render(void * data)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;
	int i;

	if(app->selected_hole >= app->course->num_holes)
	{
		return;
	}

	for(i = 0; i < MAX_HOLE_LAYERS; i++)
	{
		crsed_vert_render_layer(data, i);
	}
	for(i = 0; i < app->course->hole[app->selected_hole].bodies[app->selected_layer]; i++)
	{
		crsed_poly_render_single(data, i, (i == app->selected_poly) ? al_map_rgb(255, 255, 0) : al_map_rgb(255, 255, 255), 1);
	}
}
