#include "t3f/t3f.h"

#include "instance.h"
#include "ui_menu_proc.h"
#include "ui_vert.h"
#include "main.h"

static void crsed_hole_shortcuts(void * data)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;

	if(t3f_key[ALLEGRO_KEY_LEFT])
	{
		app->selected_hole--;
		if(app->selected_hole < 0)
		{
			app->selected_hole = app->course->num_holes - 1;
		}
		app->selected_poly = 0;
		app->selected_point = 0;
		app->selected_vert = 0;
		crsed_vert_update_live_hole(data);
		t3f_refresh_menus();
		t3f_key[ALLEGRO_KEY_LEFT] = 0;
	}
	if(t3f_key[ALLEGRO_KEY_RIGHT])
	{
		app->selected_hole++;
		if(app->selected_hole >= app->course->num_holes)
		{
			app->selected_hole = 0;
		}
		app->selected_poly = 0;
		app->selected_point = 0;
		app->selected_vert = 0;
		crsed_vert_update_live_hole(data);
		t3f_refresh_menus();
		t3f_key[ALLEGRO_KEY_RIGHT] = 0;
	}
	if(t3f_key[ALLEGRO_KEY_Z])
	{
		if(app->zoom == 1)
		{
			app->zoom = 3;
			app->ox = t3f_mouse_x * app->zoom - 320;
			if(app->ox < 0)
			{
				app->ox = 0;
			}
			else if(app->ox > 640 * app->zoom - 640)
			{
				app->ox = 640 * app->zoom - 640;
			}
			app->oy = (t3f_mouse_y - 16) * app->zoom - 240;
			if(app->oy < 0)
			{
				app->oy = 0;
			}
			else if(app->oy > 480 * app->zoom - 480)
			{
				app->oy = 480 * app->zoom - 480;
			}
		}
		else
		{
			app->zoom = 1;
			app->ox = 0;
			app->oy = 0;
		}
		t3f_key[ALLEGRO_KEY_Z] = 0;
	}
	if(t3f_key[ALLEGRO_KEY_0])
	{
		crsed_menu_poly_layer_0(0, data);
		t3f_key[ALLEGRO_KEY_0] = 0;
	}
	if(t3f_key[ALLEGRO_KEY_1])
	{
		crsed_menu_poly_layer_1(0, data);
		t3f_key[ALLEGRO_KEY_1] = 0;
	}
	if(t3f_key[ALLEGRO_KEY_2])
	{
		crsed_menu_poly_layer_2(0, data);
		t3f_key[ALLEGRO_KEY_2] = 0;
	}
}

void crsed_poly_shortcuts(void * data)
{
	if(t3f_key[ALLEGRO_KEY_DELETE])
	{
		if(KEY_EITHER_CTRL)
		{
			crsed_menu_poly_delete(0, data);
		}
		else
		{
			crsed_menu_poly_delete_vertex(0, data);
		}
		t3f_key[ALLEGRO_KEY_DELETE] = 0;
	}
}

void crsed_vert_shortcuts(void * data)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;

	if(t3f_key[ALLEGRO_KEY_DELETE])
	{
		crsed_menu_object_delete(0, data);
		t3f_key[ALLEGRO_KEY_DELETE] = 0;
	}
	if(t3f_key[ALLEGRO_KEY_8])
	{
		if(app->course->hole[app->selected_hole].vert[app->selected_vert].flag == VERT_FLAG_TREE_0)
		{
			app->course->hole[app->selected_hole].vert[app->selected_vert].radius = app->course->image_bank.object_pic[0][0]->frame[0]->width / 2;
		}
		else if(app->course->hole[app->selected_hole].vert[app->selected_vert].flag == VERT_FLAG_TREE_1)
		{
			app->course->hole[app->selected_hole].vert[app->selected_vert].radius = app->course->image_bank.object_pic[1][0]->frame[0]->width / 4;
		}
		t3f_key[ALLEGRO_KEY_8] = 0;
	}
}

void crsed_image_shortcuts(void * data)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;

	if(t3f_key[ALLEGRO_KEY_LEFT])
	{
		app->selected_image--;
		if(app->selected_image < 0)
		{
			app->selected_image = 28;
		}
		t3f_refresh_menus();
		t3f_key[ALLEGRO_KEY_LEFT] = 0;
	}
	if(t3f_key[ALLEGRO_KEY_RIGHT])
	{
		app->selected_image++;
		if(app->selected_image > 28)
		{
			app->selected_image = 0;
		}
		t3f_refresh_menus();
		t3f_key[ALLEGRO_KEY_RIGHT] = 0;
	}
}

void crsed_build_shortcuts(void * data)
{

}

void crsed_process_shortcuts(void * data)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;

	if(t3f_key[ALLEGRO_KEY_ESCAPE])
	{
		crsed_menu_file_exit(0, data);
		t3f_key[ALLEGRO_KEY_ESCAPE] = 0;
	}
	if(t3f_key[ALLEGRO_KEY_F1])
	{
		crsed_menu_help_manual(0, data);
		t3f_key[ALLEGRO_KEY_F1] = 0;
	}
	if(t3f_key[ALLEGRO_KEY_F3])
	{
		crsed_menu_file_load(0, data);
		t3f_key[ALLEGRO_KEY_F3] = 0;
	}
	if(t3f_key[ALLEGRO_KEY_F2])
	{
		if(KEY_EITHER_CTRL)
		{
			crsed_menu_file_save_as(0, data);
		}
		else
		{
			crsed_menu_file_save(0, data);
		}
		t3f_key[ALLEGRO_KEY_F2] = 0;
	}
	if(app->course)
	{
		switch(app->mode)
		{
			case CRSED_STATE_POLYGONS:
			{
				crsed_hole_shortcuts(data);
				crsed_poly_shortcuts(data);
				break;
			}
			case CRSED_STATE_OBJECTS:
			{
				crsed_hole_shortcuts(data);
				crsed_vert_shortcuts(data);
				if(t3f_key[ALLEGRO_KEY_PGUP])
				{
					crsed_menu_object_move_up(0, data);
					t3f_key[ALLEGRO_KEY_PGUP] = 0;
				}
				if(t3f_key[ALLEGRO_KEY_PGDN])
				{
					crsed_menu_object_move_down(0, data);
					t3f_key[ALLEGRO_KEY_PGDN] = 0;
				}
				break;
			}
			case CRSED_STATE_IMAGES:
			{
				crsed_image_shortcuts(data);
				break;
			}
			case CRSED_STATE_BUILD:
			{
				crsed_build_shortcuts(data);
				break;
			}
		}
		if(t3f_key[ALLEGRO_KEY_TAB])
		{
			if(KEY_EITHER_SHIFT)
			{
				app->mode--;
				if(app->mode < 0)
				{
					app->mode = CRSED_STATE_BUILD;
				}
			}
			else
			{
				app->mode++;
				if(app->mode > CRSED_STATE_BUILD)
				{
					app->mode = 0;
				}
			}
			crsed_vert_update_live_hole(data);
			t3f_refresh_menus();
			t3f_key[ALLEGRO_KEY_TAB] = 0;
		}
	}
}
