#include "t3f/t3f.h"
#include "core/course.h"
#include "core/vert.h"
#include "core/utility.h"

#include "instance.h"
#include "ui_dialog_proc.h"
#include "main.h"
#include "draw.h"
#include "ui_poly.h"
#include "ui.h"
#include "ui_menu_proc.h"

void crsed_vert_update_live_hole(void * data)
{
    APP_INSTANCE * app = (APP_INSTANCE *)data;

    memcpy(&app->live_hole, &app->course->hole[app->selected_hole], sizeof(HOLE));
    hole_initialize_verts(&app->live_hole);
}

void crsed_vert_logic(void * data)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;
	int i, j;

    crsed_camera_logic(data);
    for(i = 0; i < app->live_hole.num_verts; i++)
    {
        vert_logic(&app->live_hole.vert[i], &app->live_hole, &app->course->image_bank);
    }
	switch(app->vert_mode)
	{

		/* normal vert edit mode */
		case 0:
		{
			app->hover_vert = -1;
			app->hover_radius = -1;
			for(i = 0; i < app->course->hole[app->selected_hole].num_verts; i++)
			{
				if(app->course->hole[app->selected_hole].vert[i].layer == app->selected_layer)
				{
					switch(app->course->hole[app->selected_hole].vert[i].flag)
					{
						case VERT_FLAG_TEE:
//						case VERT_FLAG_HOLE:
//						case VERT_FLAG_TREE_0:
//						case VERT_FLAG_TREE_1:
						case VERT_FLAG_LASER_SEND:
						case VERT_FLAG_LASER_RECV:
						case VERT_FLAG_LASER_RESPAWN:
						{
							if(app->mouse_x >= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y + PEG_RADIUS)
							{
								app->hover_vert = i;
								i = 65536;
								crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
							}
							break;
						}
						case VERT_FLAG_HOLE:
						{
							if(app->mouse_x >= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y + PEG_RADIUS)
							{
								app->hover_vert = i;
								crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
								break;
							}
							else if(app->course->hole[app->selected_hole].vert[i].ref_no[1] && app->mouse_x >= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + app->course->hole[app->selected_hole].vert[i].radius - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + app->course->hole[app->selected_hole].vert[i].radius + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y + PEG_RADIUS)
							{
								app->hover_vert = i;
								app->hover_radius = i;
								crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
								i = 65536;
							}
							break;
						}
						default:
						{
							if(app->mouse_x >= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y + PEG_RADIUS)
							{
								app->hover_vert = i;
								crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
								break;
							}
							else if(app->mouse_x >= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + app->course->hole[app->selected_hole].vert[i].radius - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + app->course->hole[app->selected_hole].vert[i].radius + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y + PEG_RADIUS)
							{
								app->hover_vert = i;
								app->hover_radius = i;
								crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
								i = 65536;
							}
							break;
						}
					}
				}
			}
			if(app->hover_vert < 0 && !app->dragging)
			{
				crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_DEFAULT);
			}
			if(app->mouse_b & 1)
			{
				app->click_tick++;
				if(app->click_tick == 1)
				{
					if(app->hover_vert >= 0)
					{
						if(!app->dragging)
						{
							if(app->selected_vert != app->hover_vert)
							{
								app->selected_vert = app->hover_vert;
								t3f_refresh_menus();
							}
							app->selected_radius = app->hover_radius;
							app->peg_x = app->mouse_x - app->course->hole[app->selected_hole].vert[app->selected_vert].s.x - 320;
							app->peg_y = app->mouse_y - app->course->hole[app->selected_hole].vert[app->selected_vert].s.y - 240;
							app->dragging = 1;
						}
					}
				}
				else
				{
					if(app->dragging)
					{
                        crsed_vert_update_live_hole(data);
						if(app->selected_radius >= 0)
						{
							if(app->course->hole[app->selected_hole].vert[app->selected_vert].radius != t3f_distance(app->course->hole[app->selected_hole].vert[app->selected_vert].s.x + 320, app->course->hole[app->selected_hole].vert[app->selected_vert].s.y + 240, app->mouse_x, app->mouse_y))
							{
								app->course->hole[app->selected_hole].vert[app->selected_vert].radius = t3f_distance(app->course->hole[app->selected_hole].vert[app->selected_vert].s.x + 320, app->course->hole[app->selected_hole].vert[app->selected_vert].s.y + 240, app->mouse_x, app->mouse_y);
								if(app->course->hole[app->selected_hole].vert[app->selected_vert].radius < 0)
								{
									app->course->hole[app->selected_hole].vert[app->selected_vert].radius = -app->course->hole[app->selected_hole].vert[app->selected_vert].radius;
								}
								crsed_mark_change(data);
							}
						}
						else
						{
							if(app->course->hole[app->selected_hole].vert[app->selected_vert].s.x != app->mouse_x - app->course->hole[app->selected_hole].s.x - app->peg_x || app->course->hole[app->selected_hole].vert[app->selected_vert].s.y != app->mouse_y - app->course->hole[app->selected_hole].s.y - app->peg_y)
							{
								app->course->hole[app->selected_hole].vert[app->selected_vert].s.x = app->mouse_x - app->course->hole[app->selected_hole].s.x - app->peg_x;
								app->course->hole[app->selected_hole].vert[app->selected_vert].s.y = app->mouse_y - app->course->hole[app->selected_hole].s.y - app->peg_y;
								crsed_mark_change(data);
							}
						}
					}
				}
			}
			else if((app->mouse_b & 2) || t3f_key[ALLEGRO_KEY_INSERT])
			{
				app->click_tick++;
				if(app->click_tick == 1 && app->course->hole[app->selected_hole].num_verts < MAX_HOLE_VERTS)
				{
					app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].num_verts].s.x = app->mouse_x - 320;
					app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].num_verts].s.y = app->mouse_y - 240;
					if(app->selected_vert_type == VERT_FLAG_TREE_0)
					{
						app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].num_verts].radius = app->course->image_bank.object_pic[0][0]->frame[0]->width / 2;
					}
					else if(app->selected_vert_type == VERT_FLAG_TREE_1)
					{
						app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].num_verts].radius = app->course->image_bank.object_pic[1][0]->frame[0]->width / 2;
					}
					else
					{
						app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].num_verts].radius = 10;
					}
					app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].num_verts].flag = app->selected_vert_type;
					app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].num_verts].num_refs = 8;
					for(i = 0; i < app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].num_verts].num_refs; i++)
					{
						app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].num_verts].ref_no[i] = 0;
					}
					app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].num_verts].layer = app->selected_layer;
					app->selected_vert = app->course->hole[app->selected_hole].num_verts;
					app->course->hole[app->selected_hole].num_verts++;
                    crsed_vert_update_live_hole(data);
					t3f_refresh_menus();
					crsed_mark_change(data);
				}
			}
			else
			{
				app->click_tick = 0;
				app->dragging = 0;
			}
			break;
		}

		/* define connection between verts */
		case 1:
		{
			app->hover_vert = -1;
			app->hover_radius = -1;
			switch(app->course->hole[app->selected_hole].vert[app->selected_vert].flag)
			{
				case VERT_FLAG_PIPE_ENTER:
				{
					for(i = 0; i < app->course->hole[app->selected_hole].num_verts; i++)
					{
						if(app->mouse_x >= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y + PEG_RADIUS && app->course->hole[app->selected_hole].vert[i].flag == VERT_FLAG_PIPE_EXIT)
						{
							app->hover_vert = i;
							crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
							i = 65536;
						}
					}
					if(app->hover_vert < 0)
					{
						crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_DEFAULT);
					}
					if(app->mouse_b & 1)
					{
						app->click_tick++;
						if(app->click_tick == 1)
						{
							if(app->hover_vert >= 0 && app->hover_vert != app->selected_vert)
							{
								app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[1] = app->hover_vert;
								app->vert_mode = 0;
                                crsed_vert_update_live_hole(data);
            					t3f_refresh_menus();
            					crsed_mark_change(data);
							}
							else
							{
								app->vert_mode = 0;
							}
						}
					}
					else
					{
						app->click_tick = 0;
					}
					break;
				}
				case VERT_FLAG_TELEPORT:
				{
					for(i = 0; i < app->course->hole[app->selected_hole].num_verts; i++)
					{
						if(app->mouse_x >= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y + PEG_RADIUS && app->course->hole[app->selected_hole].vert[i].flag == VERT_FLAG_TELEPORT)
						{
							app->hover_vert = i;
							crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
							i = 65536;
						}
					}
					if(app->hover_vert < 0)
					{
						crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_DEFAULT);
					}
					if(app->mouse_b & 1)
					{
						app->click_tick++;
						if(app->click_tick == 1)
						{
							if(app->hover_vert >= 0 && app->hover_vert != app->selected_vert)
							{
								app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[0] = app->hover_vert;
								app->vert_mode = 0;
                                crsed_vert_update_live_hole(data);
            					t3f_refresh_menus();
            					crsed_mark_change(data);
							}
							else
							{
								app->vert_mode = 0;
							}
						}
					}
					else
					{
						app->click_tick = 0;
					}
					break;
				}
				case VERT_FLAG_LASER_SEND:
				{
					for(i = 0; i < app->course->hole[app->selected_hole].num_verts; i++)
					{
						if(app->mouse_x >= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y + PEG_RADIUS && app->course->hole[app->selected_hole].vert[i].flag == VERT_FLAG_LASER_RECV)
						{
							app->hover_vert = i;
							crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
							i = 65536;
						}
					}
					if(app->hover_vert < 0)
					{
						crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_DEFAULT);
					}
					if(app->mouse_b & 1)
					{
						app->click_tick++;
						if(app->click_tick == 1)
						{
							if(app->hover_vert >= 0 && app->hover_vert != app->selected_vert)
							{
								app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[5] = app->hover_vert;
								app->vert_mode = 0;
                                crsed_vert_update_live_hole(data);
            					t3f_refresh_menus();
            					crsed_mark_change(data);
							}
							else
							{
								app->vert_mode = 0;
							}
						}
					}
					else
					{
						app->click_tick = 0;
					}
					break;
				}
				case VERT_FLAG_POLY_MOTION_AREA:
				{
					for(i = 0; i < app->course->hole[app->selected_hole].num_verts; i++)
					{
						if(app->mouse_x >= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].s.x + app->course->hole[app->selected_hole].vert[i].s.x + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].s.y + app->course->hole[app->selected_hole].vert[i].s.y + PEG_RADIUS && (app->course->hole[app->selected_hole].vert[i].flag == VERT_FLAG_POLY_DOOR_HORIZ || app->course->hole[app->selected_hole].vert[i].flag == VERT_FLAG_POLY_DOOR_VERT || app->course->hole[app->selected_hole].vert[i].flag == VERT_FLAG_POLY_MOVE_HORIZ || app->course->hole[app->selected_hole].vert[i].flag == VERT_FLAG_POLY_MOVE_VERT))
						{
							app->hover_vert = i;
							crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
							i = 65536;
						}
					}
					if(app->hover_vert < 0)
					{
						crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_DEFAULT);
					}
					if(app->mouse_b & 1)
					{
						app->click_tick++;
						if(app->click_tick == 1)
						{
							if(app->hover_vert >= 0 && app->hover_vert != app->selected_vert)
							{
								switch(app->course->hole[app->selected_hole].vert[app->hover_vert].flag)
								{
									case VERT_FLAG_POLY_MOVE_HORIZ:
									{
										app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[0] = 1;
										app->vert_mode = 0;
										break;
									}
									case VERT_FLAG_POLY_MOVE_VERT:
									{
										app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[0] = 2;
										app->vert_mode = 0;
										break;
									}
									case VERT_FLAG_POLY_DOOR_HORIZ:
									{
										app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[0] = 3;
										app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[3] = app->hover_vert;
										app->vert_mode = 0;
										break;
									}
									case VERT_FLAG_POLY_DOOR_VERT:
									{
										app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[0] = 4;
										app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[3] = app->hover_vert;
										app->vert_mode = 0;
										break;
									}
								}
                                crsed_vert_update_live_hole(data);
            					t3f_refresh_menus();
            					crsed_mark_change(data);
							}
							else
							{
								app->vert_mode = 0;
							}
						}
					}
					else
					{
						app->click_tick = 0;
					}
					break;
				}
				default:
				{
					app->hover_poly = -1;
					app->hover_point = -1;
					for(i = 0; i < app->course->hole[app->selected_hole].bodies[app->selected_layer]; i++)
					{
						for(j = 0; j < app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.num_vertices; j++)
						{
							if(app->mouse_x >= app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].x + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.x - PEG_RADIUS && app->mouse_x <= app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].x + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.x + PEG_RADIUS && app->mouse_y >= app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].y + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.y - PEG_RADIUS && app->mouse_y <= app->course->hole[app->selected_hole].body[app->selected_layer][i].poly.p[j].y + app->course->hole[app->selected_hole].body[app->selected_layer][i].pos.y + PEG_RADIUS)
							{
								app->hover_poly = i;
								app->hover_point = j;
								crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_LINK);
								break;
							}
						}
					}
					if(app->hover_poly < 0)
					{
						crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_DEFAULT);
					}
					if(app->mouse_b & 1)
					{
						app->click_tick++;
						if(app->click_tick == 1)
						{
							if(app->hover_poly >= 0 && app->hover_point >= 0)
							{
								switch(app->course->hole[app->selected_hole].vert[app->selected_vert].flag)
								{
									case VERT_FLAG_POLY_MORPH:
									case VERT_FLAG_POLY_MOVE_HORIZ:
									case VERT_FLAG_POLY_MOVE_VERT:
									{
										app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[1] = app->hover_poly;
										app->vert_mode = 0;
                                        crsed_vert_update_live_hole(data);
                    					t3f_refresh_menus();
                    					crsed_mark_change(data);
										break;
									}
									case VERT_FLAG_CONVEYOR:
									{
										app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[5] = app->hover_poly;
										app->vert_mode = 0;
                                        crsed_vert_update_live_hole(data);
                    					t3f_refresh_menus();
                    					crsed_mark_change(data);
										break;
									}
									case VERT_FLAG_LAYER_TRANSFER:
									{
										app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[0] = app->hover_poly;
										app->vert_mode = 0;
                                        crsed_vert_update_live_hole(data);
                    					t3f_refresh_menus();
                    					crsed_mark_change(data);
										break;
									}
									case VERT_FLAG_TRANSLUCENCY:
									{
										app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[0] = app->hover_poly;
										app->vert_mode = 0;
                                        crsed_vert_update_live_hole(data);
                    					t3f_refresh_menus();
                    					crsed_mark_change(data);
										break;
									}
									case VERT_FLAG_POLY_DOOR_HORIZ:
									case VERT_FLAG_POLY_DOOR_VERT:
									{
										if(app->connect_count == 0)
										{
											app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[6] = app->hover_poly;
											app->connect_count++;
										}
										else
										{
											app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[7] = app->hover_poly;
											app->vert_mode = 0;
                                            crsed_vert_update_live_hole(data);
                        					t3f_refresh_menus();
                        					crsed_mark_change(data);
										}
										break;
									}
								}
							}
							else
							{
								switch(app->course->hole[app->selected_hole].vert[app->selected_vert].flag)
								{
									case VERT_FLAG_POLY_MORPH:
									case VERT_FLAG_POLY_MOVE_HORIZ:
									case VERT_FLAG_POLY_MOVE_VERT:
									case VERT_FLAG_CONVEYOR:
									case VERT_FLAG_LAYER_TRANSFER:
									case VERT_FLAG_TRANSLUCENCY:
									{
										app->vert_mode = 0;
										break;
									}
								}
							}
						}
					}
					else
					{
						app->click_tick = 0;
					}
					break;
				}
			}
			break;
		}

		/* define angle of vert */
		case 2:
		{
			crsed_set_cursor(app, ALLEGRO_SYSTEM_MOUSE_CURSOR_PRECISION);
			switch(app->course->hole[app->selected_hole].vert[app->selected_vert].flag)
			{
				case VERT_FLAG_PIPE_ENTER:
				{
					app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[4] = 128 + al_fixtoi(al_fixatan2(al_itofix(240 + app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[1]].s.y - app->mouse_y), al_itofix(320 + app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[1]].s.x - app->mouse_x)));
					if(app->mouse_b & 1)
					{
						app->click_tick++;
						if(app->click_tick == 1)
						{
							app->vert_mode = 0;
                            crsed_vert_update_live_hole(data);
        					t3f_refresh_menus();
        					crsed_mark_change(data);
						}
					}
					else
					{
						app->click_tick = 0;
					}
					break;
				}
				case VERT_FLAG_TELEPORT:
				{
					app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[1] = 128 + al_fixtoi(al_fixatan2(al_itofix(240 + app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[0]].s.y - app->mouse_y), al_itofix(320 + app->course->hole[app->selected_hole].vert[app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[0]].s.x - app->mouse_x)));
					if(app->mouse_b & 1)
					{
						app->click_tick++;
						if(app->click_tick == 1)
						{
							app->vert_mode = 0;
                            crsed_vert_update_live_hole(data);
        					t3f_refresh_menus();
        					crsed_mark_change(data);
						}
					}
					else
					{
						app->click_tick = 0;
					}
					break;
				}
				case VERT_FLAG_HOLE:
				{
					app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[2] = 128 + al_fixtoi(al_fixatan2(al_itofix(240 + app->course->hole[app->selected_hole].vert[app->selected_vert].s.y - app->mouse_y), al_itofix(320 + app->course->hole[app->selected_hole].vert[app->selected_vert].s.x - app->mouse_x)));
					if(app->mouse_b & 1)
					{
						app->click_tick++;
						if(app->click_tick == 1)
						{
							app->vert_mode = 0;
                            crsed_vert_update_live_hole(data);
        					t3f_refresh_menus();
        					crsed_mark_change(data);
						}
					}
					else
					{
						app->click_tick = 0;
					}
					break;
				}
			}
			break;
		}
	}
}

void crsed_render_vert(void * data, ALLEGRO_BITMAP * bp, HOLE * hole, int vert)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;

	switch(hole->vert[vert].flag)
	{
		case VERT_FLAG_TEE:
		{
			t3f_draw_scaled_animation(app->course->image_bank.ball_pic, t3f_color_white, 0, (hole->s.x + hole->vert[vert].s.x - vgolf_get_bitmap_width(app->course->image_bank.ball_pic) / 2) * app->zoom - app->ox, (hole->s.y + hole->vert[vert].s.y - vgolf_get_bitmap_height(app->course->image_bank.ball_pic) / 2) * app->zoom - app->oy, 0, app->zoom, 0);
			break;
		}
		default:
		{
			hole_vert_display(NULL, &hole->vert[vert], hole, &app->course->image_bank, &app->course->palette, app->ox, app->oy, app->zoom);
            hole_vert_display_single_primitive(NULL, hole, vert, &app->course->image_bank, &app->course->palette, app->ox, app->oy, app->zoom);
			break;
		}
	}
}

void crsed_render_vert_handle(void * data, ALLEGRO_BITMAP * bp, HOLE * hole, int vert)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;
	switch(hole->vert[vert].flag)
	{

		/* some objects shouldn't be resizeable (make sure program sets proper default size for hole) */
		case VERT_FLAG_TEE:
//		case VERT_FLAG_HOLE:
//		case VERT_FLAG_TREE_0:
//		case VERT_FLAG_TREE_1:
		case VERT_FLAG_LASER_SEND:
		case VERT_FLAG_LASER_RECV:
		{
			draw_handle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, (app->hover_vert == vert || app->selected_vert == vert) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
			break;
		}
		case VERT_FLAG_HOLE:
		{
			draw_handle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, ((app->hover_vert == vert && app->hover_radius < 0) || (app->selected_vert == vert && app->selected_radius < 0)) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
			if(hole->vert[vert].ref_no[1])
			{
				draw_circle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, hole->vert[vert].radius, al_map_rgb(255, 255, 255));
				draw_handle(data, bp, hole->s.x + hole->vert[vert].s.x + hole->vert[vert].radius, hole->s.y + hole->vert[vert].s.y, ((app->hover_vert == vert && app->hover_radius >= 0) || (app->selected_vert == vert && app->selected_radius >= 0)) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
			}
			if(hole->vert[vert].ref_no[1] == 254)
			{
				draw_line(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, hole->s.x + hole->vert[vert].s.x + al_fixtof(al_fixcos(al_itofix(hole->vert[vert].ref_no[2]))) * 32.0, hole->s.y + hole->vert[vert].s.y + al_fixtof(al_fixsin(al_itofix(hole->vert[vert].ref_no[2]))) * 32.0, al_map_rgb(255, 255, 255));
			}
			break;
		}
		case VERT_FLAG_PIPE_ENTER:
		{
			draw_line(data, bp, hole->s.x + hole->vert[hole->vert[vert].ref_no[1]].s.x, hole->s.y + hole->vert[hole->vert[vert].ref_no[1]].s.y, hole->s.x + hole->vert[hole->vert[vert].ref_no[1]].s.x + al_fixtof(al_fixcos(al_itofix(hole->vert[vert].ref_no[4]))) * 32.0, hole->s.y + hole->vert[hole->vert[vert].ref_no[1]].s.y + al_fixtof(al_fixsin(al_itofix(hole->vert[vert].ref_no[4]))) * 32.0, al_map_rgb(255, 255, 255));
			draw_handle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, ((app->hover_vert == vert && app->hover_radius < 0) || (app->selected_vert == vert && app->selected_radius < 0)) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
			draw_circle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, hole->vert[vert].radius, al_map_rgb(255, 255, 255));
			draw_handle(data, bp, hole->s.x + hole->vert[vert].s.x + hole->vert[vert].radius, hole->s.y + hole->vert[vert].s.y, ((app->hover_vert == vert && app->hover_radius >= 0) || (app->selected_vert == vert && app->selected_radius >= 0)) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
			break;
		}

		case VERT_FLAG_TELEPORT:
		{
			draw_line(data, bp, hole->s.x + hole->vert[hole->vert[vert].ref_no[0]].s.x, hole->s.y + hole->vert[hole->vert[vert].ref_no[0]].s.y, hole->s.x + hole->vert[hole->vert[vert].ref_no[0]].s.x + al_fixtof(al_fixcos(al_itofix(hole->vert[vert].ref_no[1]))) * 32.0, hole->s.y + hole->vert[hole->vert[vert].ref_no[0]].s.y + al_fixtof(al_fixsin(al_itofix(hole->vert[vert].ref_no[1]))) * 32.0, al_map_rgb(255, 255, 255));
			draw_handle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, ((app->hover_vert == vert && app->hover_radius < 0) || (app->selected_vert == vert && app->selected_radius < 0)) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
			draw_circle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, hole->vert[vert].radius, al_map_rgb(255, 255, 255));
			draw_handle(data, bp, hole->s.x + hole->vert[vert].s.x + hole->vert[vert].radius, hole->s.y + hole->vert[vert].s.y, ((app->hover_vert == vert && app->hover_radius >= 0) || (app->selected_vert == vert && app->selected_radius >= 0)) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
			break;
		}

		case VERT_FLAG_LASER_RESPAWN:
		case VERT_FLAG_PIPE_EXIT:
		{
			draw_handle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, ((app->hover_vert == vert && app->hover_radius < 0) || (app->selected_vert == vert && app->selected_radius < 0)) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
			draw_circle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, hole->vert[vert].radius, al_map_rgb(255, 255, 255));
			break;
		}

		/* normal objects have a position and radius */
		default:
		{
			draw_handle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, ((app->hover_vert == vert && app->hover_radius < 0) || (app->selected_vert == vert && app->selected_radius < 0)) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
			draw_circle(data, bp, hole->s.x + hole->vert[vert].s.x, hole->s.y + hole->vert[vert].s.y, hole->vert[vert].radius, al_map_rgb(255, 255, 255));
			draw_handle(data, bp, hole->s.x + hole->vert[vert].s.x + hole->vert[vert].radius, hole->s.y + hole->vert[vert].s.y, ((app->hover_vert == vert && app->hover_radius >= 0) || (app->selected_vert == vert && app->selected_radius >= 0)) ? al_map_rgba_f(0.0, 1.0, 0.0, 1.0) : t3f_color_white);
			break;
		}
	}
}

void crsed_vert_render_layer(void * data, int layer)
{
    APP_INSTANCE * app = (APP_INSTANCE *)data;
    int i;

    if(app->course->hole[app->selected_hole].layer_pic[layer])
	{
		draw_masked_bitmap2(data, app->course->hole[app->selected_hole].layer_pic[layer], NULL, 0, 0, 0, 0, 640, 480);
	}
	for(i = 0; i < app->live_hole.num_verts; i++)
	{
		if(app->live_hole.vert[i].layer == layer)
		{
			crsed_render_vert(data, NULL, &app->live_hole, i);
		}
	}
}

void crsed_vert_render(void * data)
{
	APP_INSTANCE * app = (APP_INSTANCE *)data;
	int i, r = -1;

	if(app->selected_hole >= app->course->num_holes)
	{
		return;
	}
    for(i = 0; i < MAX_HOLE_LAYERS; i++)
    {
        crsed_vert_render_layer(data, i);
    }
	if(app->vert_mode == 1 && (app->course->hole[app->selected_hole].vert[app->selected_vert].flag == VERT_FLAG_POLY_MORPH ||app->course->hole[app->selected_hole].vert[app->selected_vert].flag == VERT_FLAG_POLY_MOVE_HORIZ ||app->course->hole[app->selected_hole].vert[app->selected_vert].flag == VERT_FLAG_POLY_MOVE_VERT || app->course->hole[app->selected_hole].vert[app->selected_vert].flag == VERT_FLAG_POLY_DOOR_HORIZ || app->course->hole[app->selected_hole].vert[app->selected_vert].flag == VERT_FLAG_POLY_DOOR_VERT || app->course->hole[app->selected_hole].vert[app->selected_vert].flag == VERT_FLAG_CONVEYOR || app->course->hole[app->selected_hole].vert[app->selected_vert].flag == VERT_FLAG_LAYER_TRANSFER || app->course->hole[app->selected_hole].vert[app->selected_vert].flag == VERT_FLAG_TRANSLUCENCY))
	{
		crsed_poly_render(data);
	}
	else
	{
		if(app->course->hole[app->selected_hole].vert[app->selected_vert].layer == app->selected_layer)
		{
			switch(app->course->hole[app->selected_hole].vert[app->selected_vert].flag)
			{
				case VERT_FLAG_LAYER_TRANSFER:
				case VERT_FLAG_TRANSLUCENCY:
				{
					r = 0;
					break;
				}
				case VERT_FLAG_POLY_MORPH:
				case VERT_FLAG_POLY_MOVE_HORIZ:
				case VERT_FLAG_POLY_MOVE_VERT:
				{
					r = 1;
					break;
				}
				case VERT_FLAG_CONVEYOR:
				{
					r = 5;
					break;
				}
			}
			if(r >= 0 && app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[r] >= 0 && app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[r] < app->course->hole[app->selected_hole].bodies[app->selected_layer])
			{
				crsed_poly_render_single(data, app->course->hole[app->selected_hole].vert[app->selected_vert].ref_no[r], al_map_rgb(255, 255, 0), 1);
			}
		}
		for(i = 0; i < app->course->hole[app->selected_hole].num_verts; i++)
		{
			if(app->course->hole[app->selected_hole].vert[i].layer == app->selected_layer)
			{
				crsed_render_vert_handle(data, NULL, &app->course->hole[app->selected_hole], i);
			}
		}
	}
}
